/* myTimer -- this time used with "lsystem4" -- start up and
	manipulate MYWAVETABLE instruments depending on
	graph interpretation -- BGG/2003
*/
#include "wx/wxprec.h"

#ifndef WX_PRECOMP
	#include "wx/wx.h"
#endif

#include "myTimer.h"
#include <iostream.h>


myTimer::myTimer(wxClientDC *thedc, RTcmix *rt)
{
	wdc = thedc;
	rrr = rt;
}

void myTimer::setX(int startx)
{
	int i;

	// start up the oscillators
	for (i = 0; i < NINSTS; i++)
	{
		// dur of 999.0
		theWaves[i] = (MYWAVETABLE*)rrr->cmd("MYWAVETABLE", 5,
			0.0, 999.0, 3500.0, 500.0, 0.5);
	}
	ngoing = 0; // start with none turned up

	x = startx;
}

void myTimer::Notify()
{
	int i;
	int nosc;
	wxColour check;

	nosc = 0;
	for (i = 0; i < 500; i++)
	{
		wdc->GetPixel(x, i, &check);
		if (check.Blue() == 0)
		{
			nosc++;
			if (nosc > NINSTS) nosc = NINSTS; // just in case...

			theWaves[nosc-1]->setfreq((float)(700-i));

			if (nosc > ngoing)
			{
				theWaves[nosc-1]->startsound();
				ngoing++;
			}
		}
	}

	while(ngoing > nosc)
	{
		theWaves[ngoing-1]->stopsound();
		ngoing--;
	}


	wdc->SetPen(*wxGREEN_PEN);
	wdc->SetLogicalFunction(wxINVERT);
	wdc->DrawLine(x,0, x, 500);

	if (x > 0) wdc->DrawLine(x-1,0, x-1, 500);

	x++;
	if (x > 1000) Stop();
}
